# -*- coding: UTF-8 -*-
#!/usr/local/bin/python

#Copyright (C) 2008 by raptor
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# 批量替换文本文件内容
# author : raptor@we8log.com
# create : 2008/12/29
# revision : 2009/01/13
# revision : 2009/01/25 增加多行替换
# revision : 2009/02/21 增加文件名变量

import os
import getopt
import sys
import re
import codecs

def sed(filename, from_re, to_text, caseins=False, multiline=False, notest=False, encoding='utf-8'):
    """
f=open(sys.argv[2], "rb")
cmd='copy /b '
text=f.read(size)
while text:
    name="%s%03d" % (file, num)
    cmd += name+' + '
    open(name, "wb").write(text)
    text=f.read(size)
    num+=1
cmd=cmd[:-2]+sys.argv[2]
open("rejoin.bat", "w").write(cmd) 
    """
#    bracket_pat=re.compile(".*?\(.*?\).*?")
    try:
        f=codecs.open(filename, "r", encoding)
    except IOError:
        print "IOError file: %s" % filename
        return False
    try:
        text=f.read()
    except UnicodeDecodeError:
#        print "UnicodeDecodeError file: %s" % filename
        f.close()
        return False
    reopt=0
    if caseins:
        reopt=reopt|re.I
    if multiline:
        reopt=reopt|re.M|re.S
    pattern=re.compile(from_re, reopt)
    src_pat=re.compile("("+from_re+")", reopt)
    srcs=src_pat.findall(text)
    if srcs <> []:
        if notest:
            dest=pattern.sub(to_text, text)
            f.close()
            f=codecs.open(filename, "w", encoding)
            f.write(dest)
            result=True
        else:
            print "file : %s" % filename
            for src in srcs:
                if type(src)<>type(u"") and type(src)<>type(""):
                    src = src[0]
                print "from : %s" % src
                print "to : %s" % pattern.sub(to_text, src)
            result=False
    else:
        result=False
    f.close()
    return result

opts, args = getopt.getopt(sys.argv[1:], "rnime:")
if len(args)<2:
    print """
Usage: repall.py [-r] [-n] [-i] [-m] [-e encoding] source_regex dest_text [fileordir]
    -r : recursive subdirectories
    -n : no test
    -i : case insensitive
    -m : multiline
    -e : encoding, default is utf-8
    source_regex : regex string for source pattern
    dest_text : plain text for replacing, $FILENAME is file name string
    fileordir : filename or directory, default is current directory
    """
    sys.exit(0)
else:
    options=dict(opts)
    encoding="utf-8"
    if "-e" in options.keys():
        encoding=options["-e"]
    if len(args)>=3:
        fileordir=args[2]
    else:
        fileordir="."
    if os.path.isfile(fileordir):
        if sed(fileordir, args[0], args[1], "-i" in options.keys(), "-m" in options.keys(), "-n" in options.keys(), encoding):
            print "%s edited." % fileordir
    else:
        for root, dirs, files in os.walk( fileordir ) :
            if "-r" in options.keys() or root == fileordir:
                for filename in files:
                    to_text = args[1]
                    to_text = to_text.replace('$FILENAME', os.path.splitext(filename)[0])
                    if sed(os.path.join( root, filename ), args[0], to_text, "-i" in options.keys(), "-m" in options.keys(), "-n" in options.keys(), encoding):
                        print "%s edited." % filename


